<template>
    <div class="flex flex-col w-full h-full">
        <div class="actions absolute top-0 right-0 mt-1 mr-2 bg-white flex flex-row justify-end opacity-25 hover:opacity-75">
            <button class="text-gray-800 font-semibold py-1 px-1 rounded inline-flex items-center" v-on:click="active = !active">
                <span class=""><img svg-inline class="fill-current inline-block w-4 h-4" src="./pix/zond/list-bullet.svg" /></span>
            </button>
        </div>
        <div v-show="active" class="w-full flex flex-col ml-2 float-left border-l flex-grow">
            <div class="input flex flex-row items-left mb-1 bg-blue-200 py-1 px-2 text-sm" v-for="p in properties">
                <input class="mr-1 leading-tight flex-shrink my-auto" type="checkbox" v-model="p.checked">
                <div class="text-xs py-1 px-2 block whitespace-no-wrap flex-grow truncate capitalize my-auto">
                    {{p.key}}
                </div>
            </div>
        </div>
        <div v-show="!active" class="w-full flex flex-col ml-2 float-left border-l flex-grow">
            <div class="input flex flex-col items-left mb-1 bg-blue-200 py-1 px-2 text-sm" v-for="p in properties" v-if="p.checked">
                <label class="mb-1 text-blue-700 font-semibold capitalize truncate">{{p.key}}</label>
                <v-select v-if="p.key == 'district'" label="label" :options="districts" :reduce="district => district.value" v-model="p.value" class="w-full bg-blue-100"></v-select>
                <input v-else type="text" v-model="p.value" class="w-full bg-blue-100 h-8 border border-blue-400 rounded-md px-2" />
            </div>
        </div>
    </div>
</template>
<script>

const convertArrayToObject = (array, key) => {
  const initialValue = {};
  return array.reduce((obj, item) => {
    return {
      ...obj,
      [item[key]]: item,
    };
  }, initialValue);
};

const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;

export default {
    name: "WeeSpatialPropertyEditor",
    props: {
        universe: {
            type: Array,
            default: []
        },
        common: {
            type: Array,
            default: []
        },
        dictionary: {
            type: Object,
            default: {}
        }
    },
    data(){
        return {
            districts: DB_WB_DISTRICTS,
            active: false
        }
    },
    computed: {
        properties(){
            let self = this;
            const common   = convertArrayToObject(this.common, 'key');
            const universe = convertArrayToObject(this.universe, 'key');
            const merged   = {...common, ...universe};
            console.log("merged", merged);
            return this.universe.map(function(p){
                return {
                    checked: (p.key in common || p.key in self.dictionary), 
                    key:     p.key, 
                    value:   (p.key in self.dictionary) ? self.dictionary[p.key] : ((merged[p.key].value) ? merged[p.key].value : "")
                }
            });
        }
    },
    methods: {
        values(){
            return this.properties.filter(p => p.checked).reduce(function(acc, p){
                acc[p.key] = p.value;
                return acc;
            }, {});
        }
    }
}
</script>
<style>

</style>
